//  Simple minded matrix multiply
#include "mysched.h"
#include <stdio.h>
#include <time.h>
#include <malloc.h>
#include "triad.h"
#include <ia32intrin.h>

typedef  unsigned long long UINT64;




main(int argc,char *argv[]){
	unsigned long long start, stop, start_tot, stop_tot;
	int num, len = DIM, iter = 100, mult=1;
	char *buf1, *buf2, *buf3, *buf4;
	char *end1, *end2, *end3;
	int Offset_Addr1=128, Offset_Addr2=64, Offset_Addr3=192;
        int Offset_Addr4=0;
	int counter=0;
	double *a, *b, *c, *d, aa = 5.0;
	double cycle_sum=0., bytes, cycle_sum_tot, total_iter, bytes_per, bytes_perf;
	double best,tmp;
	int cache_level, cache_size[4], iter_mult[4];
  long cpu_x = 0;

	if(argc < 3){
		printf("test needs two arguments, targetcore and cache level, [iteration mult] %d\n",argc);
		exit(1);
	}
	cpu_x = (long) atoi(&argv[1][0]);
	cache_level = atoi(&argv[2][0]);
	if(argc == 4)mult = atoi(&argv[3][0]);
	iter = iter*mult;

  cpu_set_t cpu_set;
  CPU_ZERO( &cpu_set );
  CPU_SET( cpu_x, &cpu_set );

  if(( sched_setaffinity( 0, 64 , &cpu_set )) < 0 )
    {
      perror( "error: sched_setaffinity\n" );
      exit( 1 );
    }
  else
    {
      printf( "t0 affinitized to cpu %ld\n", cpu_x );
    }

//   factor of 4 is to get all 3 buffers into that level
	cache_size[0] = 30*1024/4;
	cache_size[1] = 250 *1024/4;
	cache_size[2] = 6 * 1024 * 1024/4;
	cache_size[3] = DIM;
	iter_mult[0] = 10*DIM/(cache_size[0]);
	iter_mult[1] = 5*DIM/(cache_size[1]);
	iter_mult[2] = 30*DIM/(cache_size[2]);
	iter_mult[3] = 1;

	iter = iter*iter_mult[cache_level];
	len = cache_size[cache_level]/8;

//malloc arrays space


	buf1 = (char *) malloc(len*(sizeof (double))+1024);
//	printf("addr of buf1 = %p\n",buf1);
	end1 = buf1 + len*sizeof(double) + 1024;
//	printf("end of buf1 = %p\n",end1);
	buf1 = buf1 + 256 - ((UINT64)buf1%256) + (UINT64)Offset_Addr1;
//	printf("addr of buf1 = %p\n",buf1);

	buf2 = (char *) malloc(len*(sizeof (double))+1024);
//	printf("addr of buf2 = %p\n",buf2);
	end2 = buf2 + len*sizeof(double) + 1024;
//	printf("end of buf2 = %p\n",end2);
	buf2 = buf2 + 256 - ((UINT64)buf2%256) + (UINT64)Offset_Addr2;
//	printf("addr of buf2 = %p\n",buf2);

	buf3 = (char *) malloc(len*(sizeof (double))+1024);
//	printf("addr of buf3 = %p\n",buf3);
	buf3 = buf3 + 256 - ((UINT64)buf3%256) + (UINT64)Offset_Addr3;
//	printf("addr of buf3 = %p\n",buf3);

	buf4 = (char *) malloc(len*(sizeof (double))+1024);
//	printf("addr of buf4 = %p\n",buf4);
	buf4 = buf4 + 256 - ((UINT64)buf4%256) + (UINT64)Offset_Addr4;
//	printf("addr of buf4 = %p\n",buf4);

	a = (double *) buf1;
	b = (double *) buf2;
	c = (double *) buf3;
	d = (double *) buf4;

	for(num=0;num<len;num++)
	{
		a[num]=10.;
		b[num]=10.;
		c[num]=10.;
		d[num]=10.;
	}

	bytes = 40.;
	bytes = bytes * (double)len;
	bytes = bytes * (double) iter;
	total_iter = (double)len;
	total_iter = total_iter * (double) iter;
	bytes = 0.;
	total_iter = 0.;
	best = 9999999999999999.;

	//start timing the triad multiply code
	printf("NUM:%d, DIM:%d, len:%d\n",NUM, DIM,len);
	start_tot = _rdtsc();
	for(num=0;num<iter;num++){
	start = _rdtsc();
	bytes_per = TRIAD(len,aa,a,b,c,d);
	aa+=0.01;
	stop = _rdtsc();
	if(stop > start){
	counter++;
	bytes+= bytes_per*(double)len;
	total_iter += (double)len;
	tmp = (double) stop - (double) start;
	cycle_sum += tmp;
	if(tmp < best)best = tmp;
	bytes_perf = bytes_per;
	}
	}
	stop_tot = _rdtsc();

	cycle_sum_tot = (double) stop_tot - (double) start_tot;

// print elapsed time
	printf("Elapsed time = %lf cycles\n",
    		cycle_sum_tot );
	printf("Elapsed time summed per iteration = %lf cycles\n",
    		cycle_sum );
	printf(" %d good timings\n",counter);
	printf("cycles per iteration = %f\n",cycle_sum/total_iter);
	printf("bytes per cycle = %f\n",bytes/cycle_sum);
	printf("best bytes per cycle = %f\n",bytes_perf*(double)len/best);
}
